/*
The following is a design of a basic priority encoder.
The input A is scanned from the least to the most significant bit for
the first occurrence of a set (Non zero) bit. The position of that
bit is output in CNT.  The position of the first bit is 1. If no bit
is set, a value of 0 is output.
The results are minimized and then printed in the form of a Berkeley PLA table.
As a last step the circuit is simulated by testing a few cases.
*/

/************* declarations ***************/
input A[8];
integer ii;
output CNT[4];

/*********** behavior description *********/
for (ii = 1,8)
{ 
    if (A[ii-1] == 1)
    {
        CNT = @ii;
        break;
    }
}
if (A == @0) CNT = @0;

/*** minimizing and printing results *******/

minimize(CNT);
writestd(1,2,CNT);

/************** simulating *****************/
for (ii = 0,255,20)
{
    values(A = @ii);
    printf(2,"A = %b    CNT = %d\n",A,CNT);
}
end;


